structure TimeLimit : sig
    exception TimeOut
    val timeLimit : Time.time -> ('a -> 'b) -> 'a -> 'b
  end = struct

    exception TimeOut

    fun timeLimit t f x = let
      fun setitimer (SOME r) =
	MLton.Itimer.set (MLton.Itimer.Real,{value=r,interval=r})
	| setitimer  NONE =
	MLton.Itimer.set (MLton.Itimer.Real,{value=Time.zeroTime,
					     interval=Time.zeroTime})
      val sigalrm = MLton.Itimer.whichSignal MLton.Itimer.Real
      fun timerOn () = ignore(setitimer (SOME t))
      fun timerOff () = ignore(setitimer NONE)
      val escapeCont = SMLofNJ.Cont.callcc (fn k => (
		SMLofNJ.Cont.callcc (fn k' => (SMLofNJ.Cont.throw k k'));
		timerOff();
		raise TimeOut))
      fun handler () = escapeCont
      val handler = MLton.Signal.Handler.simple (handler)
    in
      MLton.Signal.Handler.set (sigalrm,handler);
      timerOn();
      ((f x) handle ex => (timerOff(); raise ex))
	before timerOff()
    end
  
  end; (* TimeLimit *)